package com.shkj.framework.web.service;

import com.shkj.common.core.domain.entity.SysUser;
import com.shkj.common.core.domain.model.LoginUser;
import com.shkj.common.enums.UserStatus;
import com.shkj.common.exception.ServiceException;
import com.shkj.common.utils.SecurityUtils;
import com.shkj.common.utils.StringUtils;
import com.shkj.system.service.ISysUserService;
import org.apache.commons.collections4.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 用户验证处理
 *
 * @author lch
 */
@Service
public class UserDetailsServiceImpl implements UserDetailsService {
    private static final Logger log = LoggerFactory.getLogger(UserDetailsServiceImpl.class);

    @Autowired
    private ISysUserService userService;

    @Autowired
    private SysPermissionService permissionService;

    @Override
    public UserDetails loadUserByUsername(String usernameWid) throws UsernameNotFoundException {
        String[] split = usernameWid.split(",");
        String username = split[0];
        Long branchId = split.length > 1 ? Long.valueOf(split[1]) : SecurityUtils.erpBranchId;

        List<SysUser> users = userService.loginByUserNameAndBranchId(username, branchId);
        if (CollectionUtils.isEmpty(users)) {
            throw new ServiceException("登录用户：" + username + " 不存在");
        }
        //只有仓库级的用户才有可能存在多条数据
        if (users.size() > 1) {
            throw new ServiceException("请选择对应的仓库");
        }
        // 系统级
        //如果当前用户是管理员 并且不选仓库 进入系统管理
        //如果当前用户是管理员 并且选仓库 进入仓库管理
        //如果当前用户不是管理员 没有仓库选择 作为普通系统用户进入系统管理
        //仓库级
        //只有普通用户 并且选仓库 作为仓库普通用户进入仓库管理
        SysUser user = users.get(0);
        // 如果没有指定仓库 默认进入指定仓库的
        user.setCurrentBranchId(branchId);
        //当前是进入系统用户还是仓库用户
        user.setIsSystemUser(0);
        if (user.getIsBranchAdmin() != 1) {
            //不是管理员
            //如果当前用户不是管理员 没有仓库选择 作为普通系统用户进入系统管理 0 0
            //只有普通用户 并且选仓库 作为仓库普通用户进入仓库管理 0 A
            user.setIsBranchAdmin(0);
        } else {
            //如果当前用户是管理员 并且不选仓库 进入系统管理 1 0
            //如果当前用户是管理员 并且选仓库 进入仓库管理 1 A
        }

        //找出符合条件的一个用户
        if (StringUtils.isNull(user)) {
            log.info("登录用户：{} 不存在.", username);
            throw new ServiceException("登录用户：" + username + " 不存在");
        } else if (UserStatus.DELETED.getCode().equals(user.getDelFlag())) {
            log.info("登录用户：{} 已被删除.", username);
            throw new ServiceException("对不起，您的账号：" + username + " 已被删除");
        } else if (UserStatus.DISABLE.getCode().equals(user.getStatus())) {
            log.info("登录用户：{} 已被停用.", username);
            throw new ServiceException("对不起，您的账号：" + username + " 已停用");
        }

        return createLoginUser(user);
    }

    public UserDetails createLoginUser(SysUser user) {
        return new LoginUser(user.getUserId(), user.getDeptId(), user.getCurrentBranchId(), user.getBaseBranches().stream().map(x -> x.getId()).collect(Collectors.toList()), user, permissionService.getMenuPermission(user));
    }
}
